open Xml

let from_xml ?ns xml =
  let l = Xml_values.Load.make ?ns () in
  let rec aux = function
    | Xml.Element (tag, attrs, child) ->
	Xml_values.Load.start_elem l tag attrs;
	List.iter aux child;
	Xml_values.Load.end_elem l ()
    | Xml.PCData s ->
	Xml_values.Load.text l s
  in
  aux xml;
  Xml_values.Load.get l
	  

let from_file ?ns s =
  from_xml (Xml.parse_file s)

let from_string ?ns s =
  from_xml (Xml.parse_string s)
